!*****************************************************************************!
!* 
!*      $RCSfile: Flux_lax_friedrichs.f90,v $
!*
!*      $Revision: 1.1 $
!*
!*      $Date: 2004/01/29 09:57:48 $
!*
!*      $Author: iagmidu $
!*
!*****************************************************************************!

MODULE flux_lax_friedrichs_mod
  !--------------------------------------------------------------------------
  IMPLICIT NONE
  PRIVATE
  !----------------------------------------------------------------------------
  INTERFACE flux_lax_friedrichs
     MODULE PROCEDURE flux_lax_friedrichs
  END INTERFACE
  !----------------------------------------------------------------------------

  PUBLIC  :: flux_lax_friedrichs

CONTAINS

  SUBROUTINE flux_lax_friedrichs( gamma,  dx, dt,     &
       rho_l, rho_r, vn_l , vn_r, &
       vt_l , vt_r , p_l  , p_r , &
       flux_side                   )
    !--------------------------------------------------------------------------
    IMPLICIT NONE
    !--------------------------------------------------------------------------
    !argument list declaration
    REAL         :: gamma, dx, dt
    REAL         :: rho_l, rho_r
    REAL         :: vn_l , vn_r
    REAL         :: vt_l , vt_r
    REAL         :: p_l  , p_r
    REAL         :: flux_side(4)
    !local variable declaration
    REAL         :: e_r,e_l 
    REAL         :: a
    REAL         :: delta_u(4)
    REAL         :: f1_r(4),f1_l(4)
    !--------------------------------------------------------------------------
    INTENT(IN)   :: gamma, rho_l, rho_r, vn_l, vn_r, vt_l, vt_r, p_l, p_r 
    INTENT(OUT)  :: flux_side    
    !--------------------------------------------------------------------------

    ! Calculate left/right energy and enthalpy




    ! Calculate the differences of the conservative variables






    ! Calculalte the physical fluxes











    ! For the local Lax-Friedrichs flux use a instead of dx/dt
    ! a = MAX( abs(vn_l)+sqrt(gamma*p_l/rho_l) , abs(vn_r)+sqrt(gamma*p_r/rho_r) ) 

    ! Calculate Lax-Friedrichs flux



    RETURN
  END SUBROUTINE flux_lax_friedrichs

END MODULE flux_lax_friedrichs_mod
